' make a type that handles our intro..
Type Intro Extends AppModule
	
	Field drawCaption:Int = False
	Field anim:Animator
	
	Function Create ( resourceFile:String )
		Local i:Intro = New Intro
		i.Initialise( resourceFile, APP_INTRO )
	End Function 
	
	Method Start()
		Super.Start()
		' create an animator that will bounce our logo
		anim = Animator.CreateBounce(-500, 0, 50, 0.35, 25.0, True)
		' pause for a second here, not in the main menu
		Delay(1000)
		' play the tada sound
		PlaySoundByName( "tada" )
	End Method 
	
	Method FadeOutComplete()
		EndModule()
	End Method 
	
	Method Update( timeMS:Int )
		Super.Update( timeMS )
		' Update the bounce
		If ( Not anim.HasExpired() )
			anim.Update( timeMS )
			GetSprite("rightangle").SetPosition(200, anim.value())
			If ( anim.HasExpired() )
				' now the bounce has expired, lets spawn the caption image
				' with some particles...
				PlaySoundByName( "ding" )
				GetSprite("mbmlogo").SetPosition(380, 520)
				GetEmitter("burst").DoBurst(450, 525)
				drawCaption = True 
			End If 
		End If 			
		' check if the module should start fading away..
		If ( Not IsFading() ) ' (not already fading!)
			If ( ( GetEmitter( "burst" ).liveCount() = 0 And drawCaption = True ) Or KeyHit( KEY_ESCAPE ) )
				' basically we wait for all the particles to die or if the player hits escape
				StartFadeOut()
			End If 
		End If 
	End Method 
	
	Method Draw()
		GetSprite("rightangle").Draw()
		If (drawCaption)
			GetSprite("mbmlogo").Draw()
			GuiDrawText("Created with", 385, 500)
			GuiDrawText("All music by", 10, 500)
			GuiDrawText("www.mattmcfarland.com", 10, 540)
		EndIf
		DrawParticleEmitters()
		Super.Draw()	
	End Method 
	
End Type 

